/**
 * 试题解析
 * @author: qingwu@iflytek.com
 * @date: 14-12-24
 * @time: 上午11:29
 */
var elements = {};
var QuestionParse = QuestionParse || {};

$(function () {
    var _this = window;
    var conParseDiv = $(".container");

    /**
     * 初始化界面
     * @param json
     * @param index
     */
    _this.initialize = function (json, index) {
        if (json && json.length > 0) {
            paperParseDetail = json;
        } else {
            return;
        }
        _this.topicParse,
            hisQuestionParse = {};
        hisQuestionParse.topicListDetail = paperParseDetail.sort(QuestionParse.util.sort);
        hisQuestionParse.basePath = basePath;
        if (paperParseDetail) {
            //加载题目
            topicParse = new QuestionParse.TopicParse(hisQuestionParse);
            topicParse.init();
            //modify by qingwu:不全部加载。根据小题索引加载内容
            //conParseDiv.append(topicParse.getParseHtml());
            //conParseDiv.append(topicParse.getParseHtmlForIndex(0, 0));
            changeTopic(index);
        }
    }
    //eventDispatcher.addEventListener('initialize', initialize);


    function bindEvent() {
        var isAnswerShow = true;
        var isAnalysisShow = true;

        $('#btn_show_answer').click(function (e) {
            if (isAnswerShow) {
                $('#img_answer_arror').attr("src", "../images/arror1.png");
            } else {
                $('#img_answer_arror').attr("src", "../images/arror2.png");
            }
            $('#answer_detail').toggle(0, function () {
                if (!isAnswerShow)
                    scrollGlide.glide("box_answer", 200);
                isAnswerShow = !isAnswerShow;
            });
        })

        $('#btn_show_analysis').click(function (e) {
            if (isAnalysisShow) {
                $('#img_analysis_arror').attr("src", "../images/arror1.png");
            } else {
                $('#img_analysis_arror').attr("src", "../images/arror2.png");
            }
            $('#analysis_detail').toggle(0, function () {
                if (!isAnalysisShow)
                    scrollGlide.glide("box_analysis", 200);
                isAnalysisShow = !isAnalysisShow;
            });
        })
    }

    /**
     * 加载相应题型解析界面
     * @param index
     */
    _this.changeTopic = function (index) {
        if (typeof(topicParse) !== "undefined" && topicParse) {
            conParseDiv.empty();
            conParseDiv.append(topicParse.getParseHtmlForIndex(index));
            bindEvent();
        }
    }
    //eventDispatcher.addEventListener('changeTopic', loadTopicHtml);

    initialize(paperParseDetail, 0);
    //commAdapter.callAndroid.getJsonData();
});

/**
 * 处理试题解析页面展示、返回等
 * @returns {{evnetInit: Function}}
 */
QuestionParse.util = (function () {

    /**
     * 按题号排序
     * @param objOne
     * @param objTwo
     * @returns {number}
     */
    function sort(objOne, objTwo) {
        var valueOne = 0;
        var valueTwo = 0;
        try {
            if (typeof(objOne['topicAnalysisDTOs'][0]['topicNumber']) === 'number') {
                valueOne = objOne['topicAnalysisDTOs'][0]['topicNumber'];
            } else {
                try {
                    valueOne = parseInt(objOne['topicAnalysisDTOs'][0]['topicNumber']);
                } catch (e) {
                    valueOne = 0;
                }
            }
            if (typeof(objTwo['topicAnalysisDTOs'][0]['topicNumber']) === 'number') {
                valueTwo = objTwo['topicAnalysisDTOs'][0]['topicNumber'];
            } else {
                try {
                    valueTwo = parseInt(objTwo['topicAnalysisDTOs'][0]['topicNumber']);
                } catch (e) {
                    valueTwo = 0;
                }
            }
        } catch (e) {
            return 0;
        }
        if (valueOne < valueTwo) {
            return -1;
        } else if (valueOne > valueTwo) {
            return 1;
        } else {
            return 0;
        }
    }

    return{
        "sort": sort
    };
}());

/**
 * 答题情况 试题题型 答题概括
 */
var TopicsParse = (function () {
    function TopicsParse(options) {
        //所有题目数据
        this.topicAnalysisDTOs = options.topicAnalysisDTOs;
        //题型类别
        this.topicType = options.topicType;
        //得分
        this.score = 0;
    }

    /**
     * 生成html数据
     */
    TopicsParse.prototype.setTemplate = function () {
        var _template = "<p>" +
            "<span>{0}</span>" +
            "<span>得分：<em>{1}</em>分" +
            "</span>" +
            "</p>";
        _template += '<div class="con_list">';
        for (var i = 0; i < this.topicAnalysisDTOs.length; i++) {
            if (this.topicAnalysisDTOs[i].isCorrect) {
                if (this.topicAnalysisDTOs[i].disTitleNumber.length > 2) {
                    _template += '<i class="con_list-green" onclick="window.location.href=\'#main_' + this.topicAnalysisDTOs[i].disTitleNumber + '\'">' + this.topicAnalysisDTOs[i].disTitleNumber + '</i>';
                } else {
                    _template += '<b class="con_list_green" onclick="window.location.href=\'#main_' + this.topicAnalysisDTOs[i].disTitleNumber + '\'">' + this.topicAnalysisDTOs[i].disTitleNumber + '</b>';
                }
            } else if (this.topicAnalysisDTOs[i].score > 0 && this.topicAnalysisDTOs[i].score != this.topicAnalysisDTOs[i].standardScore) {
                if (this.topicAnalysisDTOs[i].disTitleNumber.length > 2) {
                    _template += '<i class="con_list-gary" onclick="window.location.href=\'#main_' + this.topicAnalysisDTOs[i].disTitleNumber + '\'">' + this.topicAnalysisDTOs[i].disTitleNumber + '</i>';
                } else {
                    _template += '<b class="con_list_gary" onclick="window.location.href=\'#main_' + this.topicAnalysisDTOs[i].disTitleNumber + '\'">' + this.topicAnalysisDTOs[i].disTitleNumber + '</b>';
                }
            } else {
                if (this.topicAnalysisDTOs[i].disTitleNumber.length > 2) {
                    _template += '<i class="con_list-red" onclick="window.location.href=\'#main_' + this.topicAnalysisDTOs[i].disTitleNumber + '\'">' + this.topicAnalysisDTOs[i].disTitleNumber + '</i>';
                } else {
                    _template += '<b class="con_list_red" onclick="window.location.href=\'#main_' + this.topicAnalysisDTOs[i].disTitleNumber + '\'">' + this.topicAnalysisDTOs[i].disTitleNumber + '</b>';
                }
            }
            this.setScore(this.topicAnalysisDTOs[i].score);
        }
        _template += '<div class="clear"></div></div>';
        _template = _template.replace("{0}", this.topicType).replace("{1}", this.score.toFixed(1));
        return _template;
    }

    /**
     * 设置题型总分
     */
    TopicsParse.prototype.setScore = function (score) {
        this.score += score;
    }
    return TopicsParse;
})();

/**
 * 试题解析
 */
QuestionParse.TopicParse = (function () {
    /**
     *  初始化
     *  @topicTypeList   试题分类列表
     *  @topicObj        试题分类列表
     */
    var TopicParse = function (conf) {
        this.commonUtil = new DateFormat();
        this.topicTypeList = conf.topicListDetail;
        this.basePath = conf.basePath;
        this.topicTypeListObj = [];
    };

    /**
     *  初始化题型列表-------保存题型列表
     */
    TopicParse.prototype.init = function () {
        var _this = this,
            i = 0,
            topicType = {},
            len = this.topicTypeList.length;
        for (; i < len; i++) {
            topicType = new QuestionParse.TopicParseList(this.topicTypeList[i], i + 1);
            topicType.init();
            _this.topicTypeListObj.push(topicType);
        }
    };

    /**
     *  获取答题界面所有题型界面Html
     */
    TopicParse.prototype.getParseHtml = function () {

        var i = 0,
            html = "",
            topicTypeLen = this.topicTypeListObj.length;
        for (; i < topicTypeLen; i++) {
            html += this.getTemplTopicTypeHtml({"topicType": this.topicTypeListObj[i].topicType, "topicTypeIndex": i + 1});
            var j = 0,
                topicList = this.topicTypeListObj[i].topicObj,
                topicListLen = topicList.length;
            for (; j < topicListLen; j++) {
                html += topicList[j].getHtml();
            }
        }
        return html;
    };

    /**
     * 根据索引获取当前小题的html
     * @param index
     * @returns {string}
     */
    TopicParse.prototype.getParseHtmlForIndex = function (index) {
        var topicTypeIndex = 0;
        var topicIndex = 0;
        var topicsLength = 0;
        for (var i = 0, length = this.topicTypeListObj.length; i < length; i++) {
            var currLength = this.topicTypeListObj[i].topicObj.length;
            topicsLength += currLength;
            if (index < topicsLength) {
                topicTypeIndex = i;
                topicIndex = currLength - (topicsLength - index);
                break;
            }
        }
        var html = "";
//        var topicList = this.topicTypeListObj[topicTypeIndex].topicObj;
//        html += topicList[topicIndex].getHtml();

        var topicList = this.topicTypeListObj[topicTypeIndex];
        html += topicList.getHtmlForIndex(topicIndex);
        return html;
    }

    /**
     *  绑定事件
     */
    TopicParse.prototype.bindEvent = function () {
        //目前不需要，暂时注释掉
//        var _this = this;
//        var i = 0,
//            topicTypeLen = this.topicTypeListObj.length;
//        for (; i < topicTypeLen; i++) {
//            var j = 0,
//                topicList = this.topicTypeListObj[i].topicObj,
//                topicListLen = topicList.length;
//            for (; j < topicListLen; j++) {
//                topicList[j].bindEvent();
//            }
//        }
    };

    return TopicParse;
}());
/**
 * 题型列表   初始化答题界面所有题型展示及事件
 */
QuestionParse.TopicParseList = (function () {

    /**
     *  初始化
     *  @topicList   作业详情
     *  @topicObj    题型对象
     */
    var TopicParseList = function (data, index) {
        this.topicTypeIndex = index;
        this.topicType = data.topicType;
        this.topicList = data.topicAnalysisDTOs;
        this.topicObj = [];
    };

    /**
     *  初始化题型列表-------保存题型列表
     */
    TopicParseList.prototype.init = function () {
        var _this = this,
            i = 0,
            topic = {},
            len = this.topicList.length;
        for (; i < len; i++) {
            topic = new QuestionParse.TopicParseModule(this.topicList[i], this.topicTypeIndex);
            topic.collectFn = function () {
                _this.collectFn();
            }
            topic.noteSubmitFn = function (param) {
                _this.noteSubmitFn(param);
            }
            _this.topicObj.push(topic);
        }
    };

    /**
     * 获取答题界面所有题型界面Html
     */
    TopicParseList.prototype.getHtml = function () {

        var i = 0,
            html = "",
            len = this.topicObj.length;
        for (; i < len; i++) {
            html += this.topicObj[i].getHtml(this.topicType);
        }

        return html;
    };

    /**
     * 获取答题界面某小题的界面Html
     */
    TopicParseList.prototype.getHtmlForIndex = function (index) {
        var html = this.topicObj[index].getHtml(this.topicType);
        return html;
    };

    /*
     *  绑定题型相关点击选择事件
     */
    TopicParseList.prototype.bindEvent = function () {

        var i = 0,
            len = this.topicObj.length;
        for (; i < len; i++) {
            this.topicObj[i].bindEvent();
        }

    };

    return TopicParseList;
})();


/**
 *
 * topicParseModule   答题解析Module
 *
 * 用于初始化题型
 */

QuestionParse.TopicParseModule = (function () {

    var TopicParseModule = function (data, topicTypeIndex) {

        /*数据*/
        this.topicTypeIndex = topicTypeIndex;

        this.basePath = basePath;

        this.topicsDetail = data;

        this.knowledgeName = "";

        this.levelArr = ["", "20%", "40%", "60%", "80%", "100%"];

    };

    /**
     * 获取题型HTML
     */
    TopicParseModule.prototype.getHtml = function (topicType) {
        //console.log(JSON.stringify(this.topicsDetail));
        var html = "";
        this.formatData();
        try {
            this.topicsDetail.imageAnswer = eval('(' + this.topicsDetail.imageAnswer + ')');
        } catch (e) {
            //this.topicsDetail.imageAnswer = [];
        }
        var _total = this.topicsDetail.userAnswers ? this.topicsDetail.userAnswers.length : 0;
        //var _contentHtml = this.topicsDetail.contentHtml.replace(/700px/g,"100%").replace(/<img/g,"<img width='200px'");
        var _contentHtml = "";
        //处理table
        try {
            if (this.topicsDetail.content.material) {
                _contentHtml += "<div>";
                _contentHtml += this.topicsDetail.content.material;
                _contentHtml += "</div>";
                if (this.topicsDetail.content.accessories) {
                    for (var i = 0; i < this.topicsDetail.content.accessories.length; i++) {
                        if (this.topicsDetail.content.accessories[i].desc === null || this.topicsDetail.content.accessories[i].desc === '')
                            break;
                        //显示小题题干
                        _contentHtml += "<div>";
                        _contentHtml += "(" + (i + 1) + ")";
                        _contentHtml += this.topicsDetail.content.accessories[i].desc;
                        _contentHtml += "</div>";
                        //显示小题题号
                        _contentHtml += "<div>";
                        for (var j = 0; j < this.topicsDetail.content.accessories[i].options.length; j++) {
                            _contentHtml += this.topicsDetail.content.accessories[i].options[j].id;
                            _contentHtml += ".";
                            _contentHtml += this.topicsDetail.content.accessories[i].options[j].desc;
                            _contentHtml += "<br>";
                        }
                        _contentHtml += "</div>";
                    }
                    //_contentHtml +=this.topicsDetail.content.material;
                }
            } else if (this.topicsDetail.content.accessories) {
                for (var i = 0; i < this.topicsDetail.content.accessories.length; i++) {
                    //显示小题题干
                    _contentHtml += "<div>";
                    _contentHtml += this.topicsDetail.content.accessories[i].desc;
                    _contentHtml += "</div>";

                    //显示小题题号
                    _contentHtml += "<div>";
                    for (var j = 0; j < this.topicsDetail.content.accessories[i].options.length; j++) {
                        _contentHtml += this.topicsDetail.content.accessories[i].options[j].id;
                        _contentHtml += ".";
                        _contentHtml += this.topicsDetail.content.accessories[i].options[j].desc;
                        _contentHtml += "<br>";
                    }
                    _contentHtml += "</div>";
                }
            } else {
                _contentHtml = this.topicsDetail.contentHtml;
            }
            _contentHtml = _contentHtml.replace(/700px/g, "100%");//.replace(/<img/g,"<img width='100%'");
            this.topicsDetail.answerHtml = this.topicsDetail.answerHtml.replace(/700px/g, "100%");
            this.topicsDetail.analysisHtml = this.topicsDetail.analysisHtml.replace(/700px/g, "100%");
        } catch (e) {

        }
        // html += __templTopics__({"topics": this.topicsDetail, "basePath": this.basePath, "total": _total, "contentHtml": _contentHtml});
        html += this.getTemplTopicHtml({"topics": this.topicsDetail, "topicType": topicType, "basePath": this.basePath, "total": _total, "contentHtml": _contentHtml});
        return html;
    };

    TopicParseModule.prototype.getTemplTopicHtml = function (templdata) {
        var html = "";
        html += getTopicParse();
        return html;

        //获取题干
        function getTopicParse() {
            //题干
            var html = getTopicContent();
            html += getTopicMyAnswer();
            html += getTopicAnswer();
            html += getTopocAnalysis();
            html += getKnowledge();
            return html;
        }

        //获取题面
        function getTopicContent() {
            //qingwu:在题目超出屏宽时支持题目横向滑动
            var html = "<div class='boxshadow'><div style='overflow: auto' class='subject ft14'><div class='bd'>" + templdata.contentHtml + "</div></div></div>";
            //var html = "<div class='boxshadow'><div  class='subject ft14'><div class='bd'>" + templdata.contentHtml + "</div></div></div>";
            html += "<div class='diff'><div class='main'><span class='fl'>难度：</span>";
            var level = templdata.topics.difficultyValue;
            for (var i = 0; i < 5; i++) {
                if (i < level) {
                    html += "<span class='fl star_all'><img src='../images/star1.png'></span>";
                }
                else {
                    html += "<span class='fl star_all'><img src='../images/star2.png'></span>";
                }
            }
            var scoreRate = "本班正确率：" + Math.round(templdata.topics.classScoreRate * 100);
            if (typeof templdata.topicType !== 'undefined' && templdata.topicType !== '单选题' && templdata.topicType !== '多选题')
                scoreRate = "本班得分率：" + Math.round(templdata.topics.classScoreRate * 100);
            html += "</div><div class='fr'>" + scoreRate + "%</div></div>";
            html += "</div></div><div class='clear'></div>";

            return html;
        }

        //获取我的答案
        function getTopicMyAnswer() {
            var html = "<div class='boxshadow'><div class='answer'><div class='hd ft16'><div class='fl left'><i class='fl'><img src='../images/ico1.png' width='19' height='19'></i><span class='fl'>我的答案</span></div>" +
                "<div class='fr right'>(得分" + templdata.topics.score + "/满分" + templdata.topics.standardScore + "分)</div><div class='clear'></div></div><div class='bd'>"

            if (templdata.topics.userAnswers) {
                var length = templdata.topics.userAnswers.length;
                html += "<p>";
                if (length === 1) {
                    html += templdata.topics.userAnswers[0].userAnswer;
                }
                else {
                    var tableCount = 1;
                    if (length >= 10 && length % 10 === 0) {
                        tableCount = parseInt(length / 10);
                    } else {
                        tableCount += parseInt(length / 10);
                    }

                    for (var num = 0; num < tableCount; num++) {
                        html += "<table style='border: 1px solid #CCCCCC;border-collapse:collapse;' width='100%'>";
                        var answerLength = 10;
                        var startIndex = num * 10;
                        if (num + 1 >= tableCount) {
                            answerLength = length - startIndex;
                        }
                        var endIndex = startIndex + answerLength;
                        //题号
                        html += "<tr style='border: 1px solid  #CCCCCC;text-align:center'>" +
                            "<td style='border: 1px solid  #CCCCCC;width:35px' >题号</td>";

                        var width = 630 / answerLength;
                        for (var i = startIndex; i < endIndex; i++) {
                            html += "<td style='border: 1px solid  #CCCCCC;' width='" + width + "px'>" + templdata.topics.userAnswers[i].dispTitle + "</td>"
                        }
                        html += "</tr>";

                        //答案
                        html += "<tr style='border: 1px solid #CCCCCC;text-align:center'>" +
                            "<td style='border: 1px solid  #CCCCCC;'>答案</td>";
                        for (var i = startIndex; i < endIndex; i++) {
                            var answer = templdata.topics.userAnswers[i];
                            html += "<td style='border: 1px solid  #CCCCCC;'>";
                            if (answer.isCorrect === "true" || answer.isCorrect === true)
                                html += "<font style='color:#3A926A'>" + answer.userAnswer + "</font>";
                            else
                                html += "<font style='color:#BA5656'>" + answer.userAnswer + "</font>";
                            html += "</td>"
                        }
                        html += "</tr>";
                        html += "</table>";
                    }
                }
                html += "</p>";
            }
            else if (templdata.topics.answerType === 's01Text') {
                if (!templdata.topics.userAnswer || templdata.topics.userAnswer === "null" || templdata.topics.userAnswer === null || templdata.topics.userAnswer === "")
                    html += "<p style='color:red;'>未答题</p>";
                else if (templdata.topics.userAnswer === "1")
                    html += "会";
                else if (templdata.topics.userAnswer === "0")
                    html += "不会";
                else
                    html += "<p>" + templdata.topics.userAnswer + "</p>";
            }
            else if (templdata.topics.imageAnswer) {
                html += "<p>";
                for (var i = 0, length = templdata.topics.imageAnswer.length; i < length; i++) {
                    html += "<p><img  onclick='commAdapter.callAndroid.showPhoto(\"" + templdata.topics.imageAnswer[i] + "\");' class='zx_answer' src=" + templdata.topics.imageAnswer[i] + " alt='' style='width: 100%;' /> </p>";
                }
                html += "</p>"
            }
            html += " </div></div></div> ";
            return html;
        }

        //获取知识点
        function getKnowledge() {
            if (!templdata.topics.knowledgeName || templdata.topics.knowledgeName === null || templdata.topics.knowledgeName === '')
                return"";
            return "<div class='boxshadow'><div class='knowledg'>知识点：" + templdata.topics.knowledgeName + "</div></div>";
        }

        //获取正确答案
        function getTopicAnswer() {
            console.log(templdata.topics.answerHtml);
            return "<div class='boxshadow' id='box_answer'><div class='correct'><div id='btn_show_answer' class='hd'><i class='fl'><img src='../images/ico2.png'></i>" +
                "<span class='fl'>正确答案</span><em class='fr img'><img id='img_answer_arror' width='23' height='13' src='../images/arror2.png'></em><br>" +
                "</div><div class='clear'></div><div id='answer_detail' class='bd ft14' style='overflow:auto;table-layout:fixed;word-break:break-all;'>" + templdata.topics.answerHtml + "</div></div></div>";
        }

        //获取试题解析
        function getTopocAnalysis() {
            return "<div class='boxshadow' id='box_analysis'><div class='analysis'><div id='btn_show_analysis' class='hd'><i class='fl'><img src='../images/ico3.png'></i>" +
                "<span class='fl'>试题解析</span><em class='fr'><img id='img_analysis_arror' width='23' height='13'  src='../images/arror2.png'></em><br>" +
                "</div><div class='clear'></div><div id='analysis_detail' class='bd ft14' style='overflow:auto;table-layout:fixed;word-break:break-all;'>" + templdata.topics.analysisHtml + "</div></div></div>";
        }
    }


    /**
     *  格式化数据
     */
    TopicParseModule.prototype.formatData = function () {
        if (this.topicsDetail.relatedKnowledgeGroups && this.topicsDetail.relatedKnowledgeGroups.length > 0) {
            if (this.topicsDetail.relatedKnowledgeGroups[0].relatedKnowledges && this.topicsDetail.relatedKnowledgeGroups[0].relatedKnowledges.length > 0) {
                this.topicsDetail.knowledgeName = this.topicsDetail.relatedKnowledgeGroups[0].relatedKnowledges[0].name;
            }
        }
//
//        var i= 0,
//         knowList = this.topicsDetail.relatedKnowledgeGroups,
//         len = this.topicsDetail.relatedKnowledgeGroups.length;
//
//         for(;i<len;i++){
//             if (knowList[i].knowledgeName) {
//                 this.knowledgeName = this.knowledgeName + knowList[i].knowledgeName;
//             }
//             if (knowList[i].masterRequire) {
//                 this.knowledgeName = this.knowledgeName + "<em>(" + knowList[i].masterRequire + ")</em>";
//             }
//             if (i < len - 1) {
//                 this.knowledgeName = this.knowledgeName + "、";
//             }
//
//         }

        this.topicsDetail.topicTypeIndex = this.topicTypeIndex;

        this.topicsDetail.level = this.levelArr[this.topicsDetail.difficultyValue];

    };

    /**
     *  绑定页面元素点击事件
     */
    TopicParseModule.prototype.bindEvent = function () {

    };

    return TopicParseModule;
})();