/**
 * 试题解析
 * @author: qingwu@iflytek.com
 * @date: 14-12-24
 * @time: 上午11:29
 */
var elements = {};
var QuestionParse = QuestionParse || {};

/**
 * 获取元素在数组中的下标
 * @param elem 需要定位的元素
 * @param array 数组
 * @returns {number}
 */
function inArray(elem, array) {
	if (array && array.length > 0) {
		for (var i = 0, length = array.length; i < length; i++) {
			if (array[i] == elem) {
				return i;
			}
		}
	}
	return -1;
}

$(function() {
	var _this = window;
	var conParseDiv = $(".container");

	/**
	 * 初始化界面
	 * @param json
	 * @param index
	 */
	_this.initialize = function(json, index, vip, from, isoutdate, prefix) {
		if (json) {
			paperParseDetail = json.typeTopicAnalysis;
			applyList = json.complainedTopics;
			commentList = json.answerRecordComments;
		} else {
			return;
		}
		isVip = vip;
		enterFrom = from;
		isOutDate = isoutdate;
		prefixString = prefix;
		_this.topicParse, hisQuestionParse = {};
		hisQuestionParse.topicListDetail = paperParseDetail.sort(QuestionParse.util.sort);
		hisQuestionParse.basePath = basePath;
		if (paperParseDetail) {
			//加载题目
			topicParse = new QuestionParse.TopicParse(hisQuestionParse);
			topicParse.init();
			//modify by qingwu:不全部加载。根据小题索引加载内容
			//conParseDiv.append(topicParse.getParseHtml());
			//conParseDiv.append(topicParse.getParseHtmlForIndex(0, 0));
			changeTopic(index);
		}
	}
	eventDispatcher.addEventListener('initialize', initialize);

	/**
	 * 加载相应题型解析界面
	 * @param index
	 */
	_this.changeTopic = function(index) {
		if ( typeof (topicParse) !== "undefined" && topicParse) {
			conParseDiv.empty();
			conParseDiv.append(topicParse.getParseHtmlForIndex(index));
			//如果是非VIP用户，并且是从免费考试的页面进来的
			if (isVip == 0 && enterFrom == 2) {
				var answerParseArea = $("#answer_parse_area");
				answerParseArea.empty();
				answerParseArea.append(addVipGuide());
			}
		}
	};

	_this.addVipGuide = function() {
		var html = '<div style="text-align: center;"><div class="hd ft16" >' + '<span class="clear" style="display: inline-block;color: #5acab6" class="f1" >看了试题解析就可以给学霸讲题了！<br/>还不去试试！</span></div></div>' + '<div class="tc"><img href="javascript:void(0)" onclick="commAdapter.callAndroid.showVipGuide()" width="219px" height="32px" src="../images/answer_parse_btn_content.png"></div>';
		return html;
	}
	/**
	 * 申诉成功后回调，并刷新页面
	 * @param index
	 * @param topicId
	 */
	_this.applySucceed = function(index, topicId) {
		if (inArray(topicId, applyList) < 0) {
			applyList.push(topicId);
		}
		_this.changeTopic(index);
	}
	//eventDispatcher.addEventListener('changeTopic', loadTopicHtml);
	//initialize(jsondata, 0);
	//commAdapter.callAndroid.getJsonData();
});

/**
 * 处理试题解析页面展示、返回等
 * @returns {{evnetInit: Function}}
 */
QuestionParse.util = ( function() {

		/**
		 * 按题号排序
		 * @param objOne
		 * @param objTwo
		 * @returns {number}
		 */
		function sort(objOne, objTwo) {
			var valueOne = 0;
			var valueTwo = 0;
			try {
				if ( typeof (objOne['topicAnalysisDTOs'][0]['topicNumber']) === 'number') {
					valueOne = objOne['topicAnalysisDTOs'][0]['topicNumber'];
				} else {
					try {
						valueOne = parseInt(objOne['topicAnalysisDTOs'][0]['topicNumber']);
					} catch (e) {
						valueOne = 0;
					}
				}
				if ( typeof (objTwo['topicAnalysisDTOs'][0]['topicNumber']) === 'number') {
					valueTwo = objTwo['topicAnalysisDTOs'][0]['topicNumber'];
				} else {
					try {
						valueTwo = parseInt(objTwo['topicAnalysisDTOs'][0]['topicNumber']);
					} catch (e) {
						valueTwo = 0;
					}
				}
			} catch (e) {
				return 0;
			}
			if (valueOne < valueTwo) {
				return -1;
			} else if (valueOne > valueTwo) {
				return 1;
			} else {
				return 0;
			}
		}

		return {
			"sort" : sort
		};
	}());

/**
 * 试题解析
 */
QuestionParse.TopicParse = ( function() {
		/**
		 *  初始化
		 *  @topicTypeList   试题分类列表
		 *  @topicObj        试题分类列表
		 */
		var TopicParse = function(conf) {
			this.commonUtil = new DateFormat();
			this.topicTypeList = conf.topicListDetail;
			this.basePath = conf.basePath;
			this.topicTypeListObj = [];
		};

		/**
		 *  初始化题型列表-------保存题型列表
		 */
		TopicParse.prototype.init = function() {
			var _this = this, i = 0, topicType = {}, len = this.topicTypeList.length;
			for (; i < len; i++) {
				topicType = new QuestionParse.TopicParseList(this.topicTypeList[i], i + 1);
				topicType.init();
				_this.topicTypeListObj.push(topicType);
			}
		};

		/**
		 *  获取答题界面所有题型界面Html
		 */
		TopicParse.prototype.getParseHtml = function() {

			var i = 0, html = "", topicTypeLen = this.topicTypeListObj.length;
			for (; i < topicTypeLen; i++) {
				html += this.getTemplTopicTypeHtml({
					"topicType" : this.topicTypeListObj[i].topicType,
					"topicTypeIndex" : i + 1
				});
				var j = 0, topicList = this.topicTypeListObj[i].topicObj, topicListLen = topicList.length;
				for (; j < topicListLen; j++) {
					html += topicList[j].getHtml();
				}
			}
			return html;
		};

		/**
		 * 根据索引获取当前小题的html
		 * @param index
		 * @returns {string}
		 */
		TopicParse.prototype.getParseHtmlForIndex = function(index) {
			var topicTypeIndex = 0;
			var topicIndex = 0;
			var topicsLength = 0;
			for (var i = 0, length = this.topicTypeListObj.length; i < length; i++) {
				var currLength = this.topicTypeListObj[i].topicObj.length;
				topicsLength += currLength;
				if (index < topicsLength) {
					topicTypeIndex = i;
					topicIndex = currLength - (topicsLength - index);
					break;
				}
			}
			var html = "";
			//        var topicList = this.topicTypeListObj[topicTypeIndex].topicObj;
			//        html += topicList[topicIndex].getHtml();

			var topicList = this.topicTypeListObj[topicTypeIndex];
			html += topicList.getHtmlForIndex(topicIndex);
			return html;
		}
		/**
		 *  绑定事件
		 */
		TopicParse.prototype.bindEvent = function() {
			//目前不需要，暂时注释掉
			//        var _this = this;
			//        var i = 0,
			//            topicTypeLen = this.topicTypeListObj.length;
			//        for (; i < topicTypeLen; i++) {
			//            var j = 0,
			//                topicList = this.topicTypeListObj[i].topicObj,
			//                topicListLen = topicList.length;
			//            for (; j < topicListLen; j++) {
			//                topicList[j].bindEvent();
			//            }
			//        }
		};

		return TopicParse;
	}());
/**
 * 题型列表   初始化答题界面所有题型展示及事件
 */
QuestionParse.TopicParseList = (function() {

	/**
	 *  初始化
	 *  @topicList   作业详情
	 *  @topicObj    题型对象
	 */
	var TopicParseList = function(data, index) {
		this.topicTypeIndex = index;
		this.topicType = data.topicType;
		this.topicList = data.topicAnalysisDTOs;
		this.topicObj = [];
	};

	/**
	 *  初始化题型列表-------保存题型列表
	 */
	TopicParseList.prototype.init = function() {
		var _this = this, i = 0, topic = {}, len = this.topicList.length;
		for (; i < len; i++) {
			topic = new QuestionParse.TopicParseModule(this.topicList[i], this.topicTypeIndex);
			topic.collectFn = function() {
				_this.collectFn();
			}
			topic.noteSubmitFn = function(param) {
				_this.noteSubmitFn(param);
			}
			_this.topicObj.push(topic);
		}
	};

	/**
	 * 获取答题界面所有题型界面Html
	 */
	TopicParseList.prototype.getHtml = function() {

		var i = 0, html = "", len = this.topicObj.length;
		for (; i < len; i++) {
			html += this.topicObj[i].getHtml(this.topicType);
		}

		return html;
	};

	/**
	 * 获取答题界面某小题的界面Html
	 */
	TopicParseList.prototype.getHtmlForIndex = function(index) {
		var html = this.topicObj[index].getHtml(this.topicType);
		return html;
	};

	/*
	 *  绑定题型相关点击选择事件
	 */
	TopicParseList.prototype.bindEvent = function() {

		var i = 0, len = this.topicObj.length;
		for (; i < len; i++) {
			this.topicObj[i].bindEvent();
		}

	};

	return TopicParseList;
})();

/**
 *
 * topicParseModule   答题解析Module
 *
 * 用于初始化题型
 */

QuestionParse.TopicParseModule = (function() {

	var TopicParseModule = function(data, topicTypeIndex) {

		/*数据*/
		this.topicTypeIndex = topicTypeIndex;

		this.basePath = basePath;

		this.topicsDetail = data;

		this.knowledgeName = "";

		this.levelArr = ["", "20%", "40%", "60%", "80%", "100%"];

		this.applyInfo = "";

	};

	/**
	 * 获取题型HTML
	 */
	TopicParseModule.prototype.getHtml = function(topicType) {
		//console.log(JSON.stringify(this.topicsDetail));
		var html = "";
		this.formatData();
		try {
			this.topicsDetail.imageAnswer = eval('(' + this.topicsDetail.imageAnswer + ')');
		} catch (e) {
			//this.topicsDetail.imageAnswer = [];
		}
		var _total = this.topicsDetail.userAnswers ? this.topicsDetail.userAnswers.length : 0;
		//var _contentHtml = this.topicsDetail.contentHtml.replace(/700px/g,"100%").replace(/<img/g,"<img width='200px'");
		var _contentHtml = "";
		//处理table
		try {
			if (this.topicsDetail.content.material) {
				_contentHtml += "<div>";
				_contentHtml += this.topicsDetail.content.material;
				_contentHtml += "</div>";
				if (this.topicsDetail.content.accessories) {
					for (var i = 0; i < this.topicsDetail.content.accessories.length; i++) {
						if (this.topicsDetail.content.accessories[i].desc === null || this.topicsDetail.content.accessories[i].desc === '')
							break;
						//显示小题题干
						_contentHtml += "<div>";
						_contentHtml += "(" + (i + 1) + ")";
						_contentHtml += this.topicsDetail.content.accessories[i].desc;
						_contentHtml += "</div>";

						if (this.topicsDetail.content.accessories[i].options) {
							//显示小题题号
							_contentHtml += "<div>";
							for (var j = 0; j < this.topicsDetail.content.accessories[i].options.length; j++) {
								_contentHtml += this.topicsDetail.content.accessories[i].options[j].id;
								_contentHtml += ".";
								_contentHtml += this.topicsDetail.content.accessories[i].options[j].desc;
								_contentHtml += "<br>";
							}
							_contentHtml += "</div>";
						}
					}
					//_contentHtml +=this.topicsDetail.content.material;
				}
			} else if (this.topicsDetail.content.accessories) {
				for (var i = 0; i < this.topicsDetail.content.accessories.length; i++) {
					//显示小题题干
					_contentHtml += "<div>";
					_contentHtml += this.topicsDetail.content.accessories[i].desc;
					_contentHtml += "</div>";
					if (this.topicsDetail.content.accessories[i].options) {
						//显示小题题号
						_contentHtml += "<div>";
						for (var j = 0; j < this.topicsDetail.content.accessories[i].options.length; j++) {
							_contentHtml += this.topicsDetail.content.accessories[i].options[j].id;
							_contentHtml += ".";
							_contentHtml += this.topicsDetail.content.accessories[i].options[j].desc;
							_contentHtml += "<br>";
						}
						_contentHtml += "</div>";
					}
				}
			} else {
				_contentHtml = this.topicsDetail.contentHtml;
			}
			_contentHtml = _contentHtml.replace(/700px/g, "100%");
			//.replace(/<img/g,"<img width='100%'");
			this.topicsDetail.answerHtml = this.topicsDetail.answerHtml.replace(/700px/g, "100%");
			this.topicsDetail.analysisHtml = this.topicsDetail.analysisHtml.replace(/700px/g, "100%");
		} catch (e) {

		}
		// html += __templTopics__({"topics": this.topicsDetail, "basePath": this.basePath, "total": _total, "contentHtml": _contentHtml});
		html += this.getTemplTopicHtml({
			"applyInfo" : this.applyInfo,
			"topics" : this.topicsDetail,
			"topicType" : topicType,
			"basePath" : this.basePath,
			"total" : _total,
			"contentHtml" : _contentHtml
		});
		return html;
	};

	TopicParseModule.prototype.getTemplTopicHtml = function(templdata) {
		var html = "";
		html += getTopicParse();
		return html;

		//获取题干
		function getTopicParse() {
			//题干
			var html = getTopicContent();
			html += getMyScore();
			html += getTopicMyAnswer();
			html += getRecordComment();
			html += getTopicAnswer();
			html += getTopicAnalysis();
			html += getKnowledge();
			return html;
		}

		//获取题面
		function getTopicContent() {
			//qingwu:在题目超出屏宽时支持题目横向滑动
			var html = "<div class='subject'><div style='overflow: auto'><div class='bd'>" + templdata.contentHtml + "</div></div></div>";
			html += "<div class='line'></div><div class='clear'></div>";
			return html;
		}

		function getMyScore() {
			var classScore = Math.round(templdata.topics.classScoreRate * templdata.topics.standardScore);
			var html = "<div class='score clear'><div class='hd'><i class='fl'><img src='../images/icon1.png' width='19' height='19'></i><span class='fl'>我的得分</span> " + "</div><div class='bd clearfix'><span class='fl'>得分" + templdata.topics.score + "分/满分" + templdata.topics.standardScore + "分</span><span class='fr'>本班平均得分为" + classScore + "分</span></div></div>" + "<div class='line'></div>";
			return html;
		}

		//获取我的答案
		function getTopicMyAnswer() {
			var html = "";
			var index = -1;
			if (templdata.topics.topicScoreDTOs && templdata.topics.topicScoreDTOs.length > 0) {
				for (var num = 0; num < templdata.topics.topicScoreDTOs.length; num++) {
					index = inArray(templdata.topics.topicScoreDTOs[num].topicNumber, applyList);
					if (index >= 0)
						break;
				}
			} else {
				index = inArray(templdata.topics.topicNumber, applyList);
			}
			if (index < 0) {
				var json = {};
				if (templdata.topics.topicScoreDTOs && templdata.topics.topicScoreDTOs.length > 0) {
					json.isMatermal = true;
					json.topicId = templdata.topics.topicId;
					json.topicSetId = templdata.topics.topicSetId;
					json.score = templdata.topics.score;
					json.standardScore = templdata.topics.standardScore;
					json.topicNumber = templdata.topics.topicNumber;
					json.topicScoreDTOs = templdata.topics.topicScoreDTOs;
				} else {
					json.isMatermal = true;
					json.topicId = templdata.topics.topicId;
					json.topicSetId = templdata.topics.topicSetId;
					json.score = templdata.topics.score;
					json.standardScore = templdata.topics.standardScore;
					json.topicNumber = templdata.topics.topicNumber;
				}
				templdata.applyInfo = JSON.stringify(json);
				html = "<div class='my_ans clear'><div class='hd clearfix'><div class='fl'><i class='fl'><img src='../images/icon2.png' width='15' height='19'></i><span class='fl'>我的答案</span></div>" + "<a href='javascript:void(0)'  class='fr btn' onclick='commAdapter.callAndroid.showApplyDialog(" + templdata.applyInfo + ")' ></a></div><div class='bd clearfix'>"
			} else {
				html = "<div class='my_ans clear'><div class='hd clearfix'><div class='fl'><i class='fl'><img src='../images/icon2.png' width='15' height='19'></i><span class='fl'>我的答案</span></div>" + "<span class='fr btning'></span></div><div class='bd clearfix'>"
			}

			if (templdata.topics.userAnswers) {
				var length = templdata.topics.userAnswers.length;
				html += "<p>";
				if (length === 1) {
					html += templdata.topics.userAnswers[0].userAnswer;
				} else {
					var tableCount = 1;
					if (length >= 10 && length % 10 === 0) {
						tableCount = parseInt(length / 10);
					} else {
						tableCount += parseInt(length / 10);
					}

					for (var num = 0; num < tableCount; num++) {
						html += "<table style='border: 1px solid #CCCCCC;border-collapse:collapse;' width='100%'>";
						var answerLength = 10;
						var startIndex = num * 10;
						if (num + 1 >= tableCount) {
							answerLength = length - startIndex;
						}
						var endIndex = startIndex + answerLength;
						//题号
						html += "<tr style='border: 1px solid  #CCCCCC;text-align:center'>" + "<td style='border: 1px solid  #CCCCCC;width:35px' >题号</td>";

						var width = 630 / answerLength;
						for (var i = startIndex; i < endIndex; i++) {
							html += "<td style='border: 1px solid  #CCCCCC;' width='" + width + "px'>" + templdata.topics.userAnswers[i].dispTitle + "</td>"
						}
						html += "</tr>";

						//答案
						html += "<tr style='border: 1px solid #CCCCCC;text-align:center'>" + "<td style='border: 1px solid  #CCCCCC;'>答案</td>";
						for (var i = startIndex; i < endIndex; i++) {
							var answer = templdata.topics.userAnswers[i];
							html += "<td style='border: 1px solid  #CCCCCC;'>";
							if (answer.isCorrect === "true" || answer.isCorrect === true)
								html += "<font style='color:#3A926A'>" + answer.userAnswer + "</font>";
							else
								html += "<font style='color:#BA5656'>" + answer.userAnswer + "</font>";
							html += "</td>"
						}
						html += "</tr>";
						html += "</table>";
						if (num + 1 < tableCount)
							html += "<br/>";
					}
				}
				html += "</p>";
			} else if (templdata.topics.answerType === 's01Text') {
				if (!templdata.topics.userAnswer || templdata.topics.userAnswer === "null" || templdata.topics.userAnswer === null || templdata.topics.userAnswer === "")
					html += "<p style='color:red;'>未答题</p>";
				else if (templdata.topics.userAnswer === "1")
					html += "会";
				else if (templdata.topics.userAnswer === "0")
					html += "不会";
				else
					html += "<p>" + templdata.topics.userAnswer + "</p>";
			} else if (templdata.topics.imageAnswer) {
				html += "<p>";
				if (isVip === 0 && enterFrom === 2 && isOutDate === 1) {
					html += '<div style="text-align: center;"><div class="hd ft16" >' + '<span class="clear" style="display: inline-block;color: #777777" class="f1" >仅保存最近3个月原卷，<font color="#f07023" onclick="commAdapter.callAndroid.showVipGuide()"><u>开通VIP会员</u></font>原卷永久保存</span><span class="clear" style="display: inline-block;color: #5acab6" class="f1" >试卷存储空间已满！<br/>开通会员，获取无限量存储空间！</span></div></div>' + '<div class="tc"><img href="javascript:void(0)" onclick="commAdapter.callAndroid.showVipGuide()" width="219px" height="32px" src="../images/answer_parse_btn_content.png"></div>';
				} else {
					var size = templdata.topics.topicScoreDTOs && templdata.topics.topicScoreDTOs.length;
					var length = templdata.topics.imageAnswer && templdata.topics.imageAnswer.length;
					if (size == 1) {
						var detailAnswer = templdata.topics.topicScoreDTOs[0].markingContents;
						if (detailAnswer) {
							var tempAnswer = eval('(' + detailAnswer + ')');
							var numToHtml = [];
							if (tempAnswer && tempAnswer.length > 0) {
								var detailAnswer = eval('(' + tempAnswer[0] + ')');
								var count = detailAnswer && detailAnswer.length;
								var flag1 = "json";
								if (count > 0) {
									for (var i = 0; i < count; i++) {
										if (detailAnswer[i].type) {
											var x = detailAnswer[i].x;
											//left坐标
											var y = detailAnswer[i].y;
											//top坐标
											var h = detailAnswer[i].h;
											//高度
											var type = detailAnswer[i].type;
											//类型 对 圈 叉
											var num = detailAnswer[i].num ? detailAnswer[i].num : 0;
											//序号
											var htl = '';
											if (x && y && h) {
												var srcString;
												if (type == "rightfd") {
													srcString = '../images/ic_right.png';
												} else if (type == "wrongfd") {
													srcString = '../images/ic_wrong.png';
												} else {
													srcString = '../images/ic_halfright.png';
												}
												htl += "<div style='position:absolute;height:" + h + "%;left:" + x + "%;top:" + y + "%;'><img src=" + srcString + " style='height:100%' /></div>";
											}
											numToHtml.push({
												num : num,
												html : htl
											});
										} else if ( typeof detailAnswer[i] == "string" && detailAnswer[i].indexOf("markingTrace") > -1) {
											html += "<p><img  onclick='commAdapter.callAndroid.showPhoto(\"" + prefixString + detailAnswer[i] + "\");' class='zx_answer' src=" + prefixString + detailAnswer[i] + " alt='' style='width: 100%;' /> </p>";
											flag1 = "img";
											break;
										}
									}

									if (flag1 == "json") {
										for (var i = 0; i < length; i++) {
											html += "<p><div style='position:relative;'><img onclick='commAdapter.callAndroid.showPhoto(\"" + templdata.topics.imageAnswer[i] + "\");' class='zx_answer' src=" + templdata.topics.imageAnswer[i] + " alt='' style='width: 100%;' /> ";

											var size = numToHtml && numToHtml.length;
											for (var m = 0; m < size; m++) {
												if (i == numToHtml[m].num) {
													html += numToHtml[m].html;
												}
											}

											html += "</div></p>";
										}
									}

								} else {
									for (var i = 0; i < length; i++) {
										html += "<p><img  onclick='commAdapter.callAndroid.showPhoto(\"" + templdata.topics.imageAnswer[i] + "\");' class='zx_answer' src=" + templdata.topics.imageAnswer[i] + " alt='' style='width: 100%;' /> </p>";
									}
								}
							} else {
								for (var i = 0; i < length; i++) {
									html += "<p><img  onclick='commAdapter.callAndroid.showPhoto(\"" + templdata.topics.imageAnswer[i] + "\");' class='zx_answer' src=" + templdata.topics.imageAnswer[i] + " alt='' style='width: 100%;' /> </p>";
								}
							}
						} else {
							for (var i = 0; i < length; i++) {
								html += "<p><img  onclick='commAdapter.callAndroid.showPhoto(\"" + templdata.topics.imageAnswer[i] + "\");' class='zx_answer' src=" + templdata.topics.imageAnswer[i] + " alt='' style='width: 100%;' /> </p>";
							}
						}
					} else {
						for (var j = 0; j < size; j++) {
							var detailAnswer = templdata.topics.topicScoreDTOs[j].markingContents;
							if (detailAnswer) {
								var tempAnswer = eval('(' + detailAnswer + ')');
								if (tempAnswer && tempAnswer.length > 0) {
									var detailAnswer = eval('(' + tempAnswer[0] + ')');
									var count = detailAnswer && detailAnswer.length;
									var flag2 = "json";
									if (count > 0) {
										var numToHtml = [];
										for (var i = 0; i < count; i++) {
											if ( typeof detailAnswer[i] == "string" && detailAnswer[i].indexOf("markingTrace") > -1) {
												html += "<p><img  onclick='commAdapter.callAndroid.showPhoto(\"" + prefixString + detailAnswer[i] + "\");' class='zx_answer' src=" + prefixString + detailAnswer[i] + " alt='' style='width: 100%;' /> </p>";
												flag2 = "img";
												break;
											} else if (detailAnswer[i].type) {
												var x = detailAnswer[i].x;
												//left坐标
												var y = detailAnswer[i].y;
												//top坐标
												var h = detailAnswer[i].h;
												//高度
												var type = detailAnswer[i].type;
												//类型 对 圈 叉
												var num = detailAnswer[i].num ? detailAnswer[i].num : 0;
												//序号
												var htl = '';
												if (x && y && h) {
													var srcString;
													if (type == "rightfd") {
														srcString = '../images/ic_right.png';
													} else if (type == "wrongfd") {
														srcString = '../images/ic_wrong.png';
													} else {
														srcString = '../images/ic_halfright.png';
													}
													htl += "<div style='position:absolute;height:" + h + "%;left:" + x + "%;top:" + y + "%;'><img src=" + srcString + " style='height:100%' /></div>";
												}
												numToHtml.push({
													num : num,
													html : htl
												});
											}
										}
										if (flag2 == "json") {
											html += "<p><div style='position:relative;'>";
											if (j < length) {
												html += "<img onclick='commAdapter.callAndroid.showPhoto(\"" + templdata.topics.imageAnswer[j] + "\");' class='zx_answer' src=" + templdata.topics.imageAnswer[j] + " alt='' style='width: 100%;' /> ";
											}
											var size = numToHtml && numToHtml.length;
											for (var m = 0; m < size; m++) {
												if (j == numToHtml[m].num) {
													html += numToHtml[m].html;
												}
											}
											html += "</div></p>";
										}
									} else {
										if (j < length) {
											html += "<p><img  onclick='commAdapter.callAndroid.showPhoto(\"" + templdata.topics.imageAnswer[j] + "\");' class='zx_answer' src=" + templdata.topics.imageAnswer[j] + " alt='' style='width: 100%;' /> </p>";
										}
									}
								} else {
									if (j < length) {
										html += "<p><img  onclick='commAdapter.callAndroid.showPhoto(\"" + templdata.topics.imageAnswer[j] + "\");' class='zx_answer' src=" + templdata.topics.imageAnswer[j] + " alt='' style='width: 100%;' /> </p>";
									}
								}
							} else {
								if (j < length) {
									html += "<p><img  onclick='commAdapter.callAndroid.showPhoto(\"" + templdata.topics.imageAnswer[j] + "\");' class='zx_answer' src=" + templdata.topics.imageAnswer[j] + " alt='' style='width: 100%;' /> </p>";
								}
							}

						}
					}
				}
				html += "</p>"

			}
			html += " </div></div>";
			html += "<div class='line'></div>";
			return html;
		}

		//获取老师评语
		function getRecordComment() {
			var html = "<div class='answer'><div class='hd ft16'><i class='fl'><img src='../images/icon6.png' width='19' height='19'></i><span class='fl'>老师评语</span></div>" + "<div class='bd' style='overflow:auto;table-layout:fixed;word-break:break-all;'>";
			var hasAnyComment = false;
			var size = templdata.topics.relatedKnowledgeGroups && templdata.topics.relatedKnowledgeGroups.length;
			if (size >= 1) {
				for (var j = 0; j < size; j++) {
					var topicNumber = templdata.topics.relatedKnowledgeGroups[j].topicNumber;
					if (commentList) {
						var commentObj = commentList[topicNumber];
						if (commentObj) {
							var comment = commentObj.comment;
							if (comment) {
								hasAnyComment = true;
								html += "<p>" + comment + "</p>";
							}

						}
					}
				}
			}
			if (!hasAnyComment) {
				html += "<p>无</p>";
			}
			html += "</div></div><div class='line'></div><div class='clear'></div>";
			return html;
		}

		//获取知识点
		function getKnowledge() {
			if (!templdata.topics.knowledgeName || templdata.topics.knowledgeName === null || templdata.topics.knowledgeName === '')
				return "<div class='answer'><div class='hd ft16'><i class='fl'><img src='../images/icon5.png' width='19' height='19'></i><span class='fl'>知识点：</span></div></div>"
			return "<div class='answer'><div class='hd ft16'><i class='fl'><img src='../images/icon5.png' width='19' height='19'></i><span class='fl'>知识点：" + templdata.topics.knowledgeName + "</span></div></div>"
		}

		//获取正确答案
		function getTopicAnswer() {
			return "<div class='correct'><div class='hd'><i class='fl'><img src='../images/icon3.png' width='19' height='19'></i><span class='fl'>正确答案</span>" + "</div><div class='bd' style='overflow:auto;table-layout:fixed;word-break:break-all;'>" + templdata.topics.answerHtml + "</div></div><div class='line'></div><div class='clear'></div>";
		}

		//获取试题解析
		function getTopicAnalysis() {
			return "<div class='answer'><div class='hd ft16'><i class='fl'><img src='../images/icon4.png' width='19' height='19'></i><span class='fl'>试题解析</span></div>" + "<div class='bd' id='answer_parse_area' style='overflow:auto;table-layout:fixed;word-break:break-all;'>" + templdata.topics.analysisHtml + "</div></div><div class='line'></div><div class='clear'></div>";
		}

	};

	/**
	 *  格式化数据
	 */
	TopicParseModule.prototype.formatData = function() {
		if (this.topicsDetail.relatedKnowledgeGroups && this.topicsDetail.relatedKnowledgeGroups.length > 0) {
			if (this.topicsDetail.relatedKnowledgeGroups[0].relatedKnowledges && this.topicsDetail.relatedKnowledgeGroups[0].relatedKnowledges.length > 0) {
				this.topicsDetail.knowledgeName = this.topicsDetail.relatedKnowledgeGroups[0].relatedKnowledges[0].name;
			}
		}
		this.topicsDetail.topicTypeIndex = this.topicTypeIndex;

		this.topicsDetail.level = this.levelArr[this.topicsDetail.difficultyValue];

	};

	/**
	 *  绑定页面元素点击事件
	 */
	TopicParseModule.prototype.bindEvent = function() {

	};

	return TopicParseModule;
})();
